#include <stdio.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>

void count (ino_t inumber) {

	DIR *dir;
	struct dirent *entry;
	int counter = -1;

	dir = opendir("."); /* lese aktuelles Directory */
	while ((entry = readdir(dir))) {

		/* Dateiname und Inode-Nummer ausgeben */
		printf("InodeNr. %d\t%s\n", (int)entry->d_ino, entry->d_name);
	
		if (entry->d_ino == inumber) { /* link gefunden */
			counter++;
		}

	}
	closedir(dir);
	printf("\nInodeNr. %d\t%d Hardlinks\n", (int)inumber, counter);
}

int main(int argc, char ** argv) {

    struct stat st;
	
    if (argc!=2) 			/* falsche Anzahl Argumente */
        printf("usage: %s file\n", argv[0]),
        exit(1);

    if (stat(argv[1], &st) < 0)		/* kein Zugriff auf Inode */
        perror(argv[1]),
        exit(1);

    if ((st.st_mode & S_IFMT)!=S_IFREG)	/* keine Datei */
        printf("Is not a file %s\n", argv[1]),
        exit(1);

    if (st.st_nlink == 1)		/* es existieren keine Hardlinks */
        printf("no links on file %s\n", argv[1]),
        exit(1);
                    
    count(st.st_ino);                   /* links zaehlen */
                       
    return 0;

}
