#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>

int fd;
char s[20];

/* Das Programm garantiert lediglich, dass die einzelnen */
/* Zeileninhalte (nach Druecken der Return-Taste) in einem */
/* Zug geschrieben werden. Die Zeitliche Abfolge (also die */
/* Reihenfolge, wie die Zeilen in die Lock-Datei geschrieben */
/* werden) ist mehr oder weniger zufaellig. */

/* Anwendungsbeispiel waere z.B. eine kleine Datenbank, bei */
/* die Reihenfolge der Eintraege keine Rolle spielt. */

int main(void) {

    while(scanf("%s", s) != EOF) {
		if ((fd = open("lock.txt", O_RDWR | O_CREAT, S_IRUSR | S_IWUSR)) == -1) {
		    perror("");
	    	exit(1);
		}
		lockf(fd, F_LOCK, 0);
		printf("lock[ok] %s\n", s);
		fflush(NULL);
		lseek(fd, 0, SEEK_END);
		write(fd, s, strlen(s));
		write(fd, "\n", 1);
		sleep(3);
		lseek(fd, 0, SEEK_SET);
		lockf(fd, F_ULOCK, 0);
		printf("unlocked %s\n", s);
		close(fd);
    }
    return 0;
}
